diff --git a/test/lld/adc/aos_test_adc.c b/test/lld/adc/aos_test_adc.c
new file mode 100644
index 0000000..d72bc1c
--- /dev/null
+++ b/test/lld/adc/aos_test_adc.c
@@ -0,0 +1,177 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_adc.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == TRUE) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/**
+ * @brief   Event mask of the ADC analog watchdog event.
+ */
+#define _adcWdgEventmask                        EVENT_MASK(31)
+
+/**
+ * @brief   ADC analog watchdog threshold (9.0V).
+ */
+#define _adcWdgThreshold                        (uint16_t)(9.0f / 5.0f / 3.3f * ((1 << 12) - 1) + 0.5f)
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/**
+ * @brief   Pointer to the thread listening for an ADC analog watchdog event.
+ */
+static thread_t* _listener;
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/**
+ * @brief   Helper function to convert ADC sample value to volts.
+ *
+ * @param[in] adc   ADC sample value.
+ *
+ * @return          Converted value in volts.
+ */
+static inline float _adc2volt(adcsample_t adc) {
+  return (float)adc / ((1 << 12) - 1) * 3.3f * 5.0f;
+}
+
+/**
+ * @brief   ADC analog watchdog callback function.
+ *
+ * @param[in] adcp  ADC driver.
+ * @param[in] err   ADC error value.
+ */
+static void _adcAwdCb(ADCDriver* adcp, adcerror_t err)
+{
+  (void)adcp;
+
+  if (err == ADC_ERR_WATCHDOG) {
+    chSysLockFromISR();
+    if (_listener != NULL) {
+      chEvtSignalI(_listener, _adcWdgEventmask);
+      _listener = NULL;
+    }
+    chSysUnlockFromISR();
+  }
+
+  return;
+}
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   ADC test function.
+ *
+ * @param[in] stream  Stream for input/output.
+ * @param[in] test    Test object.
+ *
+ * @return            Test result value.
+ */
+aos_testresult_t aosTestAdcFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_adcdata_t*)(test->data))->driver != NULL && ((aos_test_adcdata_t*)(test->data))->convgroup != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  adcsample_t buffer[1] = {0};
+  bool wdgpassed = false;
+  eventmask_t eventmask = 0;
+  ADCConversionGroup conversionGroup = *(((aos_test_adcdata_t*)(test->data))->convgroup);
+  conversionGroup.circular = true;
+  conversionGroup.end_cb = NULL;
+  conversionGroup.end_cb = NULL;
+  conversionGroup.htr = ADC_HTR_HT;
+  conversionGroup.ltr = 0;
+
+  chprintf(stream, "reading voltage for five seconds...\n");
+  adcStartConversion(((aos_test_adcdata_t*)(test->data))->driver, &conversionGroup, buffer, 1);
+  for (uint8_t s = 0; s < 5; ++s) {
+    aosThdSSleep(1);
+    chprintf(stream, "\tVSYS = %fV\n", _adc2volt(buffer[0]));
+  }
+  adcStopConversion(((aos_test_adcdata_t*)(test->data))->driver);
+  if (buffer[0] != 0) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "detecting external power...\n");
+  conversionGroup.error_cb = _adcAwdCb;
+  conversionGroup.htr = _adcWdgThreshold;
+  conversionGroup.ltr = _adcWdgThreshold;
+  _listener = chThdGetSelfX();
+  adcStartConversion(((aos_test_adcdata_t*)(test->data))->driver, &conversionGroup, buffer, 1);
+  eventmask = chEvtWaitOneTimeout(_adcWdgEventmask, chTimeS2I(5));
+  if (eventmask == _adcWdgEventmask) {
+    aosTestPassedMsg(stream, &result, "%fV %c 9V\n", _adc2volt(buffer[0]), (buffer[0] > _adcWdgThreshold) ? '>' : '<');
+    wdgpassed = true;
+  } else {
+    adcStopConversion(((aos_test_adcdata_t*)(test->data))->driver);
+    aosTestFailed(stream, &result);
+    wdgpassed = false;
+  }
+
+  if (wdgpassed) {
+    for (uint8_t i = 0; i < 2; ++i) {
+      if (buffer[0] > _adcWdgThreshold) {
+        chprintf(stream, "Remove external power within ten seconds.\n");
+        conversionGroup.htr = ADC_HTR_HT;
+        conversionGroup.ltr = _adcWdgThreshold;
+      } else {
+        chprintf(stream, "Connect external power within ten seconds.\n");
+        conversionGroup.htr = _adcWdgThreshold;
+        conversionGroup.ltr = 0;
+      }
+      aosThdMSleep(100); // wait some time so the ADC wil trigger again immediately due to noise
+      _listener = chThdGetSelfX();
+      adcStartConversion(((aos_test_adcdata_t*)(test->data))->driver, &conversionGroup, buffer, 1);
+      eventmask = chEvtWaitOneTimeout(_adcWdgEventmask, chTimeS2I(10));
+      if (eventmask == _adcWdgEventmask) {
+        aosTestPassedMsg(stream, &result, "%fV %c 9V\n", _adc2volt(buffer[0]), (buffer[0] > _adcWdgThreshold) ? '>' : '<');
+      } else {
+        adcStopConversion(((aos_test_adcdata_t*)(test->data))->driver);
+        aosTestFailed(stream, &result);
+        break;
+      }
+    }
+  }
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == TRUE) */
diff --git a/test/lld/adc/aos_test_adc.h b/test/lld/adc/aos_test_adc.h
new file mode 100644
index 0000000..49f90e4
--- /dev/null
+++ b/test/lld/adc/aos_test_adc.h
@@ -0,0 +1,80 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_ADC_H
+#define AMIROOS_TEST_ADC_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == TRUE) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  ADCDriver* driver;
+
+  /**
+   * @brief   Pointer to the conversion group to use.
+   */
+  ADCConversionGroup* convgroup;
+} aos_test_adcdata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestAdcFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == TRUE) */
+
+#endif /* AMIROOS_TEST_ADC_H */
+
diff --git a/test/periphery-lld/A3906_v1/aos_test_A3906.c b/test/periphery-lld/A3906_v1/aos_test_A3906.c
new file mode 100644
index 0000000..fd6c47a
--- /dev/null
+++ b/test/periphery-lld/A3906_v1/aos_test_A3906.c
@@ -0,0 +1,290 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_A3906.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <stdlib.h>
+#include <math.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/**
+ * @brief   Interval to poll QEI in certain tests.
+ */
+#define QEI_POLL_INTERVAL_MS          100
+
+/**
+ * @brief   Threshold for QEI differences.
+ * @details Differences smaller than or equal to this value are neglected (interpreted as zero).
+ *          The value can be interpreted as encoder ticks per second (tps).
+ * @note    The expected value is about 7000 tps and a jitter of up to ±2% is ok.
+ */
+#define QEI_DIFF_THRESHOLD            (apalQEICount_t)(7000 * 0.02f)
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/**
+ * @brief   Enumerator to distinguish between left and right wheel.
+ */
+typedef enum {
+  WHEEL_LEFT    = 0,  /**< left wheel identifier */
+  WHEEL_RIGHT   = 1,  /**< right wheel identifier */
+} wheel_t;
+
+/**
+ * @brief   Enumerator to distinguish directions.
+ */
+typedef enum {
+  DIRECTION_FORWARD   = 0,  /**< forward direction identifier */
+  DIRECTION_BACKWARD  = 1,  /**< backward direction identifier */
+} direction_t;
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/**
+ * @brief   helper function to test each wheel and direction separately.
+ *
+ * @param[in] stream      Stream for input/output.
+ * @param[in] data        Test meta data.
+ * @param[in] wheel       Wheel to test.
+ * @param[in] direction   Direction to test.
+ * @param[in,out] result  Result variable to modify.
+ */
+void _wheelDirectionTest(BaseSequentialStream* stream, aos_test_a3906data_t* data, wheel_t wheel, direction_t direction, aos_testresult_t* result)
+{
+  // local variables
+  uint32_t status;
+  bool qei_valid;
+  apalQEICount_t qei_count[2];
+  apalQEIDirection_t qei_direction;
+  uint32_t timeout_counter;
+
+  chprintf(stream, "%s wheel %s...\n", (wheel == WHEEL_LEFT) ? "left" : "right", (direction == DIRECTION_FORWARD) ? "forward" : "backward");
+  qei_valid = false;
+  status = apalQEIGetPosition((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_count[0]);
+  // increase PWM incrementally and read QEI data
+  for (apalPWMwidth_t pwm_width = APAL_PWM_WIDTH_MIN; pwm_width < APAL_PWM_WIDTH_MAX; ++pwm_width) {
+    status |= a3906_lld_set_pwm(data->pwm.driver, (wheel == WHEEL_LEFT) ?
+                                  ((direction == DIRECTION_FORWARD) ? data->pwm.channel.left_forward : data->pwm.channel.left_backward) :
+                                  ((direction == DIRECTION_FORWARD) ? data->pwm.channel.right_forward : data->pwm.channel.right_backward),
+                                pwm_width);
+    status |= apalQEIGetPosition((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_count[1]);
+    qei_valid = qei_valid || (qei_count[0] != qei_count[1]);
+    aosThdUSleep(5 * MICROSECONDS_PER_SECOND / (APAL_PWM_WIDTH_MAX - APAL_PWM_WIDTH_MIN));
+    qei_count[0] = qei_count[1];
+  }
+  status |= qei_valid ? 0x00 : 0x10;
+  status |= apalQEIGetDirection((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_direction);
+  status |= (qei_direction == ((direction == DIRECTION_FORWARD) ? APAL_QEI_DIRECTION_UP : APAL_QEI_DIRECTION_DOWN)) ? 0x00 : 0x20;
+
+  // let the wheel spin free until it stops
+  status |= a3906_lld_set_pwm(data->pwm.driver, (wheel == WHEEL_LEFT) ?
+                                ((direction == DIRECTION_FORWARD) ? data->pwm.channel.left_forward : data->pwm.channel.left_backward) :
+                                ((direction == DIRECTION_FORWARD) ? data->pwm.channel.right_forward : data->pwm.channel.right_backward),
+                              0);
+  qei_count[0] = 0;
+  qei_count[1] = 0;
+  timeout_counter = 0;
+  do {
+    status |= apalQEIGetPosition((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_count[0]);
+    aosThdMSleep(1);
+    status |= apalQEIGetPosition((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_count[1]);
+    ++timeout_counter;
+  } while ((qei_count[0] != qei_count[1]) && (timeout_counter * MICROSECONDS_PER_MILLISECOND <= data->timeout));
+  status |= (timeout_counter * MICROSECONDS_PER_MILLISECOND > data->timeout) ? APAL_STATUS_TIMEOUT : 0x00;
+
+  // report result
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, result);
+  } else {
+    aosTestFailedMsg(stream, result, "0x%08X\n", status);
+  }
+
+  return;
+}
+
+void _wheelSpeedTest(BaseSequentialStream* stream, aos_test_a3906data_t* data, wheel_t wheel, direction_t direction, aos_testresult_t* result)
+{
+  // local variables
+  uint32_t status;
+  apalQEICount_t qei_range;
+  apalQEICount_t qei_count[2] = {0};
+  apalQEICount_t qei_increments[2] = {0};
+  apalQEICount_t qei_increments_diff = 0;
+  uint32_t timeout_counter = 0;
+  uint32_t stable_counter = 0;
+
+  chprintf(stream, "%s wheel full speed %s...\n", (wheel == WHEEL_LEFT) ? "left" : "right", (direction == DIRECTION_FORWARD) ? "forward" : "backward");
+  // spin up the wheel with full speed
+  status = apalQEIGetRange((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_range);
+  status |= a3906_lld_set_pwm(data->pwm.driver, (wheel == WHEEL_LEFT) ?
+                               ((direction == DIRECTION_FORWARD) ? data->pwm.channel.left_forward : data->pwm.channel.left_backward) :
+                               ((direction == DIRECTION_FORWARD) ? data->pwm.channel.right_forward : data->pwm.channel.right_backward),
+                             APAL_PWM_WIDTH_MAX);
+  aosThdMSleep(100);
+  do {
+    // read QEI data to determine speed
+    status |= apalQEIGetPosition((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_count[0]);
+    aosThdMSleep(QEI_POLL_INTERVAL_MS);
+    status |= apalQEIGetPosition((wheel == WHEEL_LEFT) ? data->qei.left : data->qei.right, &qei_count[1]);
+    timeout_counter += QEI_POLL_INTERVAL_MS;
+    qei_increments[0] = qei_increments[1];
+    qei_increments[1] = (direction == DIRECTION_FORWARD) ?
+                          ((qei_count[1] > qei_count[0]) ? (qei_count[1] - qei_count[0]) : (qei_count[1] + (qei_range - qei_count[0]))) :
+                          ((qei_count[0] > qei_count[1]) ? (qei_count[0] - qei_count[1]) : (qei_count[0] + (qei_range - qei_count[1])));
+    qei_increments_diff = abs((int32_t)qei_increments[0] - (int32_t)qei_increments[1]) * ((float)MILLISECONDS_PER_SECOND / (float)QEI_POLL_INTERVAL_MS);
+    stable_counter = ((qei_increments[0] != 0 || qei_increments[1] != 0) && qei_increments_diff <= QEI_DIFF_THRESHOLD) ? stable_counter+1 : 0;
+    if (qei_increments[0] != 0 && stable_counter == 0) {
+      chprintf(stream, "\tunstable speed? jitter of %u tps is above threshold (%u tps).\n", qei_increments_diff, QEI_DIFF_THRESHOLD);
+    }
+  } while ((stable_counter* QEI_POLL_INTERVAL_MS < MILLISECONDS_PER_SECOND) && (timeout_counter * MICROSECONDS_PER_MILLISECOND <= data->timeout));
+  status |= a3906_lld_set_pwm(data->pwm.driver, (wheel == WHEEL_LEFT) ?
+                               ((direction == DIRECTION_FORWARD) ? data->pwm.channel.left_forward : data->pwm.channel.left_backward) :
+                               ((direction == DIRECTION_FORWARD) ? data->pwm.channel.right_forward : data->pwm.channel.right_backward),
+                             APAL_PWM_WIDTH_OFF);
+  status |= (timeout_counter * MICROSECONDS_PER_MILLISECOND > data->timeout) ? APAL_STATUS_TIMEOUT : 0x00;
+
+  // report results
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, result);
+    const float tps = qei_increments[1] * ((float)MILLISECONDS_PER_SECOND / (float)QEI_POLL_INTERVAL_MS);
+    const float rpm = tps * SECONDS_PER_MINUTE / (float)data->qei.increments_per_revolution;
+    const float velocity = tps / (float)data->qei.increments_per_revolution * ((wheel == WHEEL_LEFT) ? data->wheel_diameter.left : data->wheel_diameter.right) * acos(-1);
+    chprintf(stream, "\t%f tps\n", tps);
+    chprintf(stream, "\t%f RPM\n", rpm);
+    chprintf(stream, "\t%f m/s\n", velocity);
+    chprintf(stream, "\n");
+  }
+  else {
+    aosTestFailedMsg(stream, result, "0x%08X\n", status);
+  }
+}
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   A3905 test function.
+ *
+ * @param[in] stream  Stream for input/output.
+ * @param[in] test    Test object.
+ *
+ * @return            Test result value.
+ */
+aos_testresult_t aosTestA3906Func(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck((test->data != NULL) &&
+              (((aos_test_a3906data_t*)test->data)->driver != NULL) &&
+              (((aos_test_a3906data_t*)test->data)->pwm.driver != NULL) &&
+              (((aos_test_a3906data_t*)test->data)->qei.left != NULL) &&
+              (((aos_test_a3906data_t*)test->data)->qei.right != NULL));
+
+
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status = 0;
+  a3906_lld_power_t power_state;
+  apalQEICount_t qei_count[2][2];
+  uint32_t timeout_counter;
+  uint32_t stable_counter;
+
+  chprintf(stream, "enable power...\n");
+  power_state = A3906_LLD_POWER_ON;
+  status = a3906_lld_set_power(((aos_test_a3906data_t*)test->data)->driver, power_state);
+  status |= a3906_lld_get_power(((aos_test_a3906data_t*)test->data)->driver, &power_state);
+  status |= (power_state != A3906_LLD_POWER_ON) ? 0x10 : 0x00;
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  _wheelDirectionTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_LEFT, DIRECTION_FORWARD, &result);
+
+  _wheelDirectionTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_RIGHT, DIRECTION_FORWARD, &result);
+
+  _wheelDirectionTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_LEFT, DIRECTION_BACKWARD, &result);
+
+  _wheelDirectionTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_RIGHT, DIRECTION_BACKWARD, &result);
+
+  _wheelSpeedTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_LEFT, DIRECTION_FORWARD, &result);
+
+  _wheelSpeedTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_RIGHT, DIRECTION_FORWARD, &result);
+
+  _wheelSpeedTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_LEFT, DIRECTION_BACKWARD, &result);
+
+  _wheelSpeedTest(stream, (aos_test_a3906data_t*)test->data, WHEEL_RIGHT, DIRECTION_BACKWARD, &result);
+
+  chprintf(stream, "disable power...\n");
+  power_state = A3906_LLD_POWER_OFF;
+  status = a3906_lld_set_power(((aos_test_a3906data_t*)test->data)->driver, power_state);
+  status |= a3906_lld_get_power(((aos_test_a3906data_t*)test->data)->driver, &power_state);
+  status |= (power_state != A3906_LLD_POWER_OFF) ? 0x10 : 0x00;
+  qei_count[WHEEL_LEFT][0] = 0;
+  qei_count[WHEEL_LEFT][1] = 0;
+  qei_count[WHEEL_RIGHT][0] = 0;
+  qei_count[WHEEL_RIGHT][1] = 0;
+  timeout_counter = 0;
+  stable_counter = 0;
+  do {
+    status |= apalQEIGetPosition(((aos_test_a3906data_t*)test->data)->qei.left, &qei_count[WHEEL_LEFT][0]);
+    status |= apalQEIGetPosition(((aos_test_a3906data_t*)test->data)->qei.right, &qei_count[WHEEL_RIGHT][0]);
+    aosThdMSleep(1);
+    status |= apalQEIGetPosition(((aos_test_a3906data_t*)test->data)->qei.left, &qei_count[WHEEL_LEFT][1]);
+    status |= apalQEIGetPosition(((aos_test_a3906data_t*)test->data)->qei.right, &qei_count[WHEEL_RIGHT][1]);
+    ++timeout_counter;
+    stable_counter = (qei_count[WHEEL_LEFT][0] == qei_count[WHEEL_LEFT][1] && qei_count[WHEEL_RIGHT][0] == qei_count[WHEEL_RIGHT][1]) ? stable_counter+1 : 0;
+  } while((stable_counter < 100) && (timeout_counter * MICROSECONDS_PER_MILLISECOND <= ((aos_test_a3906data_t*)test->data)->timeout));
+  status |= (timeout_counter * MICROSECONDS_PER_MILLISECOND > ((aos_test_a3906data_t*)test->data)->timeout) ? APAL_STATUS_TIMEOUT : 0x00;
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  // stop the PWM
+  a3906_lld_set_pwm(((aos_test_a3906data_t*)test->data)->pwm.driver, ((aos_test_a3906data_t*)test->data)->pwm.channel.left_forward, APAL_PWM_WIDTH_OFF);
+  a3906_lld_set_pwm(((aos_test_a3906data_t*)test->data)->pwm.driver, ((aos_test_a3906data_t*)test->data)->pwm.channel.left_backward, APAL_PWM_WIDTH_OFF);
+  a3906_lld_set_pwm(((aos_test_a3906data_t*)test->data)->pwm.driver, ((aos_test_a3906data_t*)test->data)->pwm.channel.right_forward, APAL_PWM_WIDTH_OFF);
+  a3906_lld_set_pwm(((aos_test_a3906data_t*)test->data)->pwm.driver, ((aos_test_a3906data_t*)test->data)->pwm.channel.right_backward, APAL_PWM_WIDTH_OFF);
+
+  aosTestInfoMsg(stream,"driver object memory footprint: %u bytes\n", sizeof(A3906Driver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/A3906_v1/aos_test_A3906.h b/test/periphery-lld/A3906_v1/aos_test_A3906.h
new file mode 100644
index 0000000..03423f4
--- /dev/null
+++ b/test/periphery-lld/A3906_v1/aos_test_A3906.h
@@ -0,0 +1,151 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_A3906_H
+#define AMIROOS_TEST_A3906_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_A3906.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  A3906Driver* driver;
+
+  /**
+   * @brief   PWM driver information.
+   */
+  struct {
+    /**
+     * @brief   The PWM driver to use.
+     */
+    apalPWMDriver_t* driver;
+
+    /**
+     * @brief   PWM channel information.
+     */
+    struct {
+      /**
+     * @brief   PWM channel for the left wheel forward direction.
+     */
+      apalPWMchannel_t left_forward;
+
+      /**
+     * @brief   PWM channel for the left wheel backward direction.
+     */
+      apalPWMchannel_t left_backward;
+
+      /**
+     * @brief   PWM channel for the right wheel forward direction.
+     */
+      apalPWMchannel_t right_forward;
+
+      /**
+     * @brief   PWM channel for the right wheel backward direction.
+     */
+      apalPWMchannel_t right_backward;
+    } channel;
+  } pwm;
+
+  /**
+   * @brief   QEI driver information
+   */
+  struct {
+    /**
+     * @brief   QEI driver for the left wheel.
+     */
+    apalQEIDriver_t* left;
+
+    /**
+     * @brief   QEI driver for the right wheel.
+     */
+    apalQEIDriver_t* right;
+
+    /**
+     * @brief   QEI increments per wheel revolution.
+     */
+    apalQEICount_t increments_per_revolution;
+  } qei;
+
+  /**
+   * @brief   Wheel diameter information.
+   */
+  struct {
+    /**
+     * @brief   Left wheel diameter in m.
+     */
+    float left;
+
+    /**
+     * @brief   Right wheel diameter in m.
+     */
+    float right;
+  } wheel_diameter;
+
+  /**
+   * @brief   Timeout value (in us).
+   */
+  apalTime_t timeout;
+} aos_test_a3906data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestA3906Func(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_A3906_H */
